

# <center>Fab Academy Week  Machine Design</center>


<center>![]()</center>
<center>![]()</center>
<!---     --><!---     --><!---     --><!---     --><!---     -->
<!---     -->

##### **Resources:**

* http://academy.cba.mit.edu/classes/machine_design/index.html

This week we are looking at Machine design i.e mechanisms + actuation + automation.

In Neil's class he took us on a tour of the design strategies of designing machines.

<!---    
machines,
modules,  objects, video
mechanisms


fablabs  -  help you automate processing... its a meta lab!


## Object oriented software in hardware.

weirdly I found this paper  whilst I was looking for press kit help for grasshopper.


rapid compositions

structural loops, error budgets,

Error budget -  design to an error

Structural loops  - the path load

make power modular so that surgess of current come through clocal currents rather than globally.

In networking we saw real time networks

Singel board radios


you can do about 1000 microprocessor per macroscoping mocement of the machine.. so you can build a mchaine netwrok.. movemets talking to eachother rather than a central ontroller.



specifications

sensors, actuators
end effectors
power electronics
real-time networks


### paths
   static, dynamic


water jet cutters
path of the jet needs to be caluclated - dynamic path planning/

Rigid machines are expensive





### motion control
   open-loop,

#### closed-loop

instead of telling it what steps to make you tell it where to go to

capacitive backgammon



### control theory
   bang-bang, measure position  - turn on current to the motor and when it gets there you turn pof... turn on turn off. its terrible  because the machine lurches . it doesnt stop effectively

    PID,
 - proportional integral  derivative - either electrically or software to take the difference between postions -  you get an error signal..
- difference term is the p term error term gfeeds into the motor. Error never gets to zero
intergal  - integrates the base line (adds it to the error)
- Derivative  (dfference in time) 3 stages i think
so the current starts gets steep then curves back down,
a microcontroller c
you tune a PID controller.

    acceleration,
Model predictive control -

.model predictive,

ramoing down befre getting to the set point like an ven oterwise it over heat
so you have these different inpit profiles based on prediction or to smooth the motion / poewwer surges


acceleratuin
theres a limit ovn velocity and limits on scceleration - how fast are you willing to accelerate?

profile of machine can bue built around the profile.


online optimization


tensorflow for machine learning trains a model.
downlhill simplex - error inthe machine and searcher finds the settings.. machine learning in the machine - conytroller in he machine - something that measures performance c
constraints


you optimise and have a machine train a model to learn how to contrl itsel surprisingly accessible..


gradient descent - assumes you have amodel of the gradient - you sample observations - nonstead ofmmo


MECH ENG + MACHINE LEARNING

This is really important and I am keen to at least get some experience in this befoere the end of term..


real time network


TIMING
  handshake, broadcast, time-stamp, back-pressure
how to choreograpgher three degrees of freedom  -
 handshaking - you tell a motor to something and it comes back to confirm - you shalke hands wtheach degree f freedom -

 ### broadcasts

 broadcast methode - send a message to eackh motor - then you send another global onethat says to do it/.

timestamps
 -

### back pressure

data into an output buffer
the rate they pull data tell yoo where they are

###



## implementation - machine controller

machine control
   virtual, dataflow, video



can be a software abstraction - virtual machine controll  the degrees of freedom are in the machine
they are all connected with a real time network - controller has to schedule messages directly

user interface - talks to a motion controller and that talks to

machine to motion controll

gestalt - oython program defines the logic of the machine and takes over the scheduile -  

machines - can generate data that communoicates back t you really easily..

rapid machine building
jake.. building modules ar logical modules .... a machine composer.



- motor controllers are nodes oin the network
- network interface

b- built thelogic in mods - machine control in the mods
so you can add modules to add degrees of freedom and collectDATA

aimed around real time machine control
egrapid machine building

222
 REAL TIME DEGREE OF NODES


### file formats,

rolad speak RO
g code more commonn - what codes can you interpreter interpret  - your g code has to go to something c=that can take g code to machine instruction (distance per step etc)

gerber?

#### interpreters

tiny G

 limited degrees of frreedom - hardware


### User interfaces


chillipepper
https://github.com/synthetos/TinyG/wiki/Chilipeppr
 web based interfcace

nice machine nterfacec - strongly recomended for G cide


### path planning
plan the path in the machone e.g mods.

look at mods oto see image mapping

1. calculating sdistance to the nearwest edge  - distanc e transforms edges
distance transform - happens in
read each row in both directions and down and up to decide what is a boundary.

size of the tool and distance does the offset - uwhere you need to go o be a certain distance from the bounday

then find edges

then orient them

vectorise

record assembles vectorise aths and miniises tool movement

takes tool path and formats it tto rml

last one takes

COMPUTATION GEOMETRY!



### representing designs


functional representations

!



hierarchical - matt keeter - distance fields

  designs to machine  - distance fields  -
  triangle sloose information and distance field  -

  distance field based on x2 + y2 + z 2

  F
  LOOK UP UNCTIONAL REPRESENTTIONS

### component  from vendors


  openbuilds
  OpenBuilds, RobotShop
  Pololu (cheap), Synthetos, Replicape, RAMPS

motors with  custmomisable control - ..
  Stepper Online, Just Motion Control, Wantai, Oriental Motors,

  vendor can customise the motor for you

### machines that build machines -fabable machines


  Jens,
  Danielle ingrasia  - laser cutters!

  , Jake - he's built the softwwre - virtual machne controllers over hardwrae




  opensource laser cutters





### actuate and automate your machine

online optimization
axis motor position


control loops

theres a link to a nice briefcase transportable kit. one position satisfies all of the constraints this is a bit like the lego analogy.

turns into a 3d printet.

Popfab

milling head and cutting head
> life beyond file interpreter

I am really interested in modeular machines especially ones that generate code sue to their position.






timing
   handshake, broadcast, time-stamp, back-pressure



machine control
   virtual, dataflow, video
file formats, interpreters
user interface
path planning
design representation



## group assignment
   - actuate and automate your machine
   - document the group project and your individual contribution


link mehanical with actuation plus automation to make a machine

on your own page say what you did yourself.

sooftware , ma=icrocde etch


actuation + automation+ mechanisms



each machine project needs a 1 minute video

goal is to get a feeling that you can make a machine - any sort of integration will do.


june
 -->
